      SUBROUTINE GSTIFF8(BIG)
C--------------------------------------------------------------
C
C     For each individual element...
C     (1) Extracts element data from global arrays
C     (2) Calls 'routines to compute element matrices
C     (3) Sets up the earthing parameter "BIG"
C
C----------------------------------------------------------

      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 KA,KB,KC,KD,KE,KM
      INCLUDE 'STRESS2D.CCM'     
      
      DIMENSION X(8),Y(8),PRESS(8),LNODS(8),              
     .   XX(2),YY(2),PRESSS(2),LLNODS(2),DEL(16),
C     .   ELS(16,16),EF(16),ELSS(4,4),EFF(4),LDEST(2000)
     .   ELS(16,16),EF(16),ELSS(4,4),EFF(4),LDEST(NDOF*MAXNODES)
     
      DO 54 J=1,MAXBAND          !ORIGINALLY200
      DO 54 I=1,NDOF*MAXNODES    ! 2000  !initialises stiffness matrix
 54   A(I,J)=0.0
      DO 901 I=1,1000     !initialises force vector
 901  B(I)=0.0

      KSTOP=0
      DO 300 NEL=1,NELEMZ
      MAT=LMAT(NEL)
      E=PROP(MAT,1)
      GNU=PROP(MAT,2)
      IF(LLTYP(NEL).EQ.1) THEN    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      DO 40 I=1,8                 !for 8-noded elements
      NODE=LTOP(I,NEL)            !
      LNODS(I)=NODE               !forms element stiffness
      PRESS(I)=RLOAD(NODE)        !
      X(I)=GX(NODE)               !matrix
 40   Y(I)=GY(NODE)               !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      KEY=0                        
      CALL EL16(X,Y,E,GNU,ELS,EF,NGAUSS,KEY,KLASS)
      KSTOP=KSTOP+KEY
      IF(KEY.NE.0) GOTO 300
               IF(NEL.EQ.1) THEN   
               CALL BIG16(ELS,BIG)    !earthing parameter 'BIG'
               IF(ECHO) WRITE(6,602)BIG
               ENDIF
      IF(KPRES.NE.0)
     .       CALL PRES16(X,Y,KPRES,PRESS,EF,NGAUSS,KEY,KLASS)
C
C            ***PRES16 assembles force vector from uniform pressure***
C 
      KSTOP=KSTOP+KEY
      IF(KEY.EQ.0) 
     .       CALL ASS16(A,B,NVABZ,KWIDTH,ELS,EF,LNODS)
c            ***ASS16 assembles global stiffness matrix and force vector***
       ENDIF
  300  CONTINUE



      RETURN
 601  FORMAT(//,' JOB ABORTED IN GSTIFF8 ...   ',/,
     1  ' DUE TO ERRORS DETECTED IN EL16/PRES16  ....  ')
 602  FORMAT(/' EARTHING PARAMETER "BIG" =',E10.3/)
      END

$ 