C============================================================
      SUBROUTINE INDAT(NODENO,NNG,NLC,NES,NELSTR,NOSP,NSPGR,
     1            NCON,afcp,SHFORST,NW,NERROR,MXITER,NSTAT,
     2            NGROUP)
C------------------------------------------------------------
C
C     Reads the input data from file 5.
C
C-----------------------------------------------------------
C
C   ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C  NOTE:--- RKAS AND ASSOCIATED VARIABLES ARE STORED VERY INEFFICIENTLY
C         CHANGE METHOD OF STORAGE WHEN GOT THE CHANCE....DELETE THIS 
C            MESSAGE IF CHANGE MADE
C   vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
C


      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 KA,KB,KC,KD,KE,KM
      INCLUDE 'STRESS2D.CCM'      
 

      DIMENSION TITLE(20),LN(8),NGASH(5),NODENO(MAXNODES),NELSTR(300),
     1          NSPGR(300),afcp(300),SHFORST(300)

      READ(5,7776) ECHO    !true if input data is to be echoed
      READ(5,7776) UNI_LIN !true if unilinear results are to be printed
      READ(5,7776) TRI_LIN_ALL !true if ALL TRIlinear results to be printed
 7776 FORMAT(L5)

      IF(.NOT.ECHO) WRITE(6,7775)
 7775 FORMAT(///,10X,'NO ECHO OF INPUT DATA REQUESTED (SEE DATA FILE)'
     * ,///)
      IF(.NOT.UNI_LIN) WRITE(6,7774)
 7774 FORMAT(///,10X,'NO OUTPUT OF UNILINEAR RESULTS REQUESTED',///)
      IF(.NOT.TRI_LIN_ALL) WRITE(6,7773)
 7773 FORMAT(///,10X,'LIMITED OUTPUT OF TRILINEAR RESULTS REQUESTED'
     * ,///)


      READ(5,*)KLASS
 
      IF(KLASS.LT.1.OR.KLASS.GT.3)THEN
        IF(ECHO) WRITE(6,7777)
 7777  FORMAT(///,10X,'KLASS OUT SIDE PRESCRIBED LIMITS...',
     * //,49X,'JOB ABORTED IN INDAT')
      STOP
      END IF

     
      IF((ECHO).AND.(KLASS.EQ.1))    WRITE(6,626)
      IF((ECHO).AND.(KLASS.EQ.2))    WRITE(6,627)
      IF((ECHO).AND.(KLASS.EQ.3))    WRITE(6,628)

      DO 2 I=1,MXNOD        !NODEZ  !initialise
      GX(I)=0.
      GY(I)=0.
 2    RLOAD(I)=0.

      IF(ECHO) WRITE(6,600)
      READ(5,501)TITLE
      IF(ECHO) WRITE(6,601)TITLE
      NGAUSS=2                  ! default Gauss rule 
      IF(ECHO) WRITE(6,604)NGAUSS      


      IF(ECHO) WRITE(6,602)
      READ(5,*)NELEMZ,NODEZ
            IF(MXEL.LT.NELEMZ) THEN
               IF(ECHO) WRITE(6,651)MXEL,NELEMZ
               STOP
               ENDIF
            IF(MXNOD.LT.NODEZ) THEN
               IF(ECHO) WRITE(6,652)MXNOD,NODEZ
               STOP
               ENDIF
      IF(ECHO) WRITE(6,603)NELEMZ,NODEZ
      NVABZ=NVN*NODEZ
      IF(ECHO) WRITE(6,605)NVABZ
            IF(MXAI.LT.NVABZ) THEN
            IF(ECHO) WRITE(6,653)MXAI,NVABZ
            STOP
            ENDIF


      READ(5,*)NMAT            !no. of materials
      IF(ECHO) WRITE(6,620)NMAT
            IF(MXMAT.LT.NMAT) THEN
            IF(ECHO) WRITE(6,624)MXMAT,NMAT
            STOP
            ENDIF

      IF(ECHO) WRITE(6,621)
      DO 8 N=1,NMAT
      READ(5,*)I,(PROP(I,J),J=1,2)
 8    IF(ECHO) WRITE(6,622)I,(PROP(I,J),J=1,2)

      DO 17 N=1,NELEMZ         !read element type
 17   LLTYP(N)=1               !take tpye 1 by default
 13   READ(5,*)LTYP,NGASH
      IF(LTYP.LE.0)GOTO 111
      DO 112 N=1,5
      IF(NGASH(N).EQ.0)GOTO 112
      NEL=NGASH(N)
      LLTYP(NEL)=LTYP
 112  CONTINUE
      GOTO 13
 111  IF(ECHO) WRITE(6,633)
      IF(ECHO) WRITE(6,644)(N,LLTYP(N),N=1,NELEMZ)

      READ(5,*)NOSP      !no. of springs
      DO 91 N=1,NOSP
      READ(5,*)ISP      ! READ SPRING NO.
      NSPGR(N)=ISP
      RKAS(ISP,1)=0.0   !INITIALIZING X SPRING STIFFNESSES 
      RKAS(ISP,2)=9E+07   !INITIALIZING y spring stiffnesses
 91    CONTINUE

      READ(5,*)NSG   !READ NO. OF STUD GROUPS
      DO 513 I=1,NSG
       READ(5,*)K,SSS(I)   !ELEMENT NO. OF STUD GROUP, 
C                                      STATIC SHEAR STIFFNESS 
       NSTUD(I)=K
       RKAS(K,1)=SSS(I)
       IF(ECHO) WRITE(6,503)
       IF(ECHO) WRITE(6,502)NSTUD(I),SSS(I)
  513 CONTINUE
  502 FORMAT(2X,I3,9X,E11.4)
  503 FORMAT(1X,'STUD GROUP',1X,'STATIC SHEAR STIFFNESS')

      READ(5,*)NNG       !NO.OF NODES WHERE DATA IS REQUIRED CONTINUALLY
      DO 1010 N=1,NNG
	 READ(5,*)NODENO(N)   ! NODE NUMBER 
 1010 CONTINUE

      READ(5,*)NES       !NO.OF ELEMENTS WHERE STRESS2S ARE REQUIRED 
C                         THROUGHOUT ANALYSIS
      DO 1012 N=1,NES
	 READ(5,*)NELSTR(N)
 1012 CONTINUE

      DO 10 N=1,NELEMZ
 10   LMAT(N)=1              !type 1 by default
 12   READ(5,*)MATNO,NGASH
      IF(MATNO.LE.0) GOTO 16
      DO 14 N=1,5
      IF(NGASH(N).EQ.0) GOTO 14
      NEL=NGASH(N)
      LMAT(NEL)=MATNO
 14   CONTINUE
      GOTO 12
 16   IF(ECHO) WRITE(6,623)
      IF(ECHO) WRITE(6,624)(N,LMAT(N),N=1,NELEMZ)
C
      IF(ECHO) WRITE(6,606)
      KSTOP=0
      DO 50 N=1,NELEMZ      !element nodal list
      READ(5,*)I,LN
      IF(ECHO) WRITE(6,607)I,LN
      IF(I.EQ.N) GOTO 20
      IF(ECHO) WRITE(6,608)
      KSTOP=1
      GOTO 50
 20   DO 30 J=1,8
      IF(LN(J).LE.NODEZ) GOTO 30
      IF(ECHO) WRITE(6,609) LN(J)
      KSTOP=1
 30   LTOP(J,N)=LN(J)
 50   CONTINUE
            IF(KSTOP.NE.0) STOP

      IF(ECHO) WRITE(6,610)
 80   READ(5,*)N,AX,AY         !x & y co-ords of nodes
      IF(N.LE.0)GOTO 100
            IF(N.LE.NODEZ)GOTO 90
            IF(ECHO) WRITE(6,611)N
            GOTO 80
 90   GX(N)=AX
      GY(N)=AY
      IF(ECHO) WRITE(6,612)N,GX(N),GY(N)
      GOTO 80
 100  CONTINUE

      IF(ECHO) WRITE(6,613)
      READ(5,*)NFIXZ          !no. of fixities
      IF(ECHO) WRITE(6,614)NFIXZ
            IF(MXFIX.LT.NFIXZ) THEN
            IF(ECHO) WRITE(6,625)MXFIX,NFIXZ
            STOP
            ENDIF
      IF(ECHO) WRITE(6,615)
      DO 150 N=1,NFIXZ
      READ(5,*)NODE,KODE       !fixed nodes, fixity code
      IF(ECHO) WRITE(6,616)NODE,KODE
 150  NFIX(N)=NODE*10000  +  KODE
 
      DO 132 NUMB=1,20
 132  DSP(NUMB)=0.0
      READ(5,*)NDISP          !no. of applied displacements
      IF(NDISP.LE.0)GOTO 777
      DO 888 I=1,NDISP 
      READ(5,*)NODE,L,D       !node no.,dirctn. of disp.,magnitude of disp.
      IF(ECHO) WRITE(6,690)NODE,L,D    !           1 X DIR
      NNODE(I)=NODE           !           2 Y DIR
      LLDIR(I)=L
      DSP(I)=D
 888  CONTINUE

 777  KPRES=0
      IF(ECHO) WRITE(6,617)
 155  READ(5,*)NPRES          !uniform load pointer
      IF(NPRES.GT.0) THEN  
            KPRES=NPRES
            READ(5,*)CPRESS,NGASH   !uniform load ; nodes groups of five
            IF(ECHO) WRITE(6,618)CPRESS,NGASH
            DO 170 K=1,5
            NODE=NGASH(K)
            IF(NODE.NE.0) RLOAD(NODE)=CPRESS
 170        CONTINUE  
            GOTO 155 
            ENDIF 

            READ(5,*)NUM          !no. of point loads
            IF(NUM.LE.0) GOTO 909
            IF(ECHO) WRITE(6,648)
            DO 255 I=1,NUM
            IF(ECHO) WRITE(6,512)
  512       FORMAT(1X,'NODE NO',2X,'DIR. OF LOAD',2X,'MAX STATIC LOAD')
            READ(5,*)N,L,FMX  !NODE NO., DIR. OF LOAD, MAX STATIC LOAD
            IF(ECHO) WRITE(6,511)N,L,FMX
 511        FORMAT(2X,I3,5X,I2,5X,F8.0)
            IF(ECHO) WRITE(6,507) 
            READ(5,*)NLC           !NO. OF LOAD CYCLES


            DO 508 J=1,NLC
            READ(5,*)NCYC(J),FPK(J),FMN(J) !NO. OF CYCLES ,PEAK LOAD ,MIN. LOAD


            IF(ECHO) WRITE(6,506)NCYC(J),FPK(J),FMN(J)
  508       CONTINUE
  506       FORMAT(1X,I8,2X,F8.0,5X,F8.0)
  507       FORMAT(1X,'NO.OF CYCLES',2X,'PEAK LOAD',2X,'MIN. LOAD')



            LNOAD(I)=N
            LDR(I)=L
            GLOAD(I)=FMX
 255  CONTINUE


 909  CONTINUE
      READ(5,*)MXITER         !140,MAX ITERATIONS IN INCREMENTAL 
      IF(ECHO) WRITE(6,793)MXITER      !ANALYSIS
 793  FORMAT(1X,'MXITER=',I4)             
      READ(5,*)NERROR         !IF 0 NO ADJUSTEMT OF FSET OTHERWISE
      IF(ECHO) WRITE(6,792)NERROR      !1=R function N 2=R function slip
 792  FORMAT(1X,'NERROR=',I3)
      READ(5,*)NW             !IF NW EQUALS 1 OUTPUT NOT LIMITED
      IF(ECHO) WRITE(6,790)NW
 790  FORMAT(1X,'NW=',I3)
      READ(5,*)NSTAT          !IF NSTAT EQUALS 1 STATIC OUTPUT GIVEN
      IF(ECHO) WRITE(6,794)NSTAT
 794  FORMAT(1X,'NSTAT=',I3)
      READ(5,*)NGROUP         !IF NGROUP EQUALS 1 TERMINATED AFTER FIRST
      IF(ECHO) WRITE(6,795)NGROUP      !GROUP OF STUDS HAS FAILED
 795  FORMAT(1X,'NGROUP=',I3) 
      READ(5,*)KA             !2.8,RATIO OF FATIGUE TO STATIC STIFFNESS
      IF(ECHO) WRITE(6,789)KA          
 789  FORMAT(1X,'KA=',F7.3)
      READ(5,*)KB             !1.7E-5, CONSTANT OF FATIGUE SET PREDICTION
      IF(ECHO) WRITE(6,788)KB
 788  FORMAT(1X,'KB=',E10.4)
      READ(5,*)KC             !750, ALLOWABLE ERROR IN N OF SHEAR FLOW
      IF(ECHO) WRITE(6,786)KC
 786  FORMAT(1X,'KC=',F9.0)
      READ(5,*)KD             !4,INVERSE OF PROPORTIONAL ADJUSTMENT OF SHPK
      IF(ECHO) WRITE(6,785)KD
 785  FORMAT(1X,'KD=',F7.3)
      READ(5,*)KM             !4.55,EXPONENTIAL OF FATIGUE LIFE AND SET
      IF(ECHO) WRITE(6,784)KM          !PREDICTION EQUATIONS
 784  FORMAT(1X,'KM=',F7.3)
      READ(5,*)KE             !2344, CONSTANT OF FATIGUE LIFE PREDICTION
      IF(ECHO) WRITE(6,783)KE          !EQUATIONS
 783  FORMAT(1X,'KE=',F9.3)

      IF(ECHO) WRITE(6,776)
      DO I=1,NSG
       K=NSTUD(I)
       READ(5,*)PSH(K),DS(K)
       IF(ECHO) WRITE(6,778)K,PSH(K),DS(K)
      END DO

      READ(5,*)NCON      !IF NCON.EQ.1 THEN INTERMEDIATE START 
      IF(ECHO) WRITE(6,791)NCON
 791  FORMAT(1X,'NCON=',I3)
      IF (NCON.EQ.1) THEN
	DO 999 I=1,NSG
	K=NSTUD(I)
      	READ(5,*)SHPK(k),SHMN(K),PSET(K),FSET(K),SHFORST(K),
     .  	AFCP(K)
        IF(ECHO) WRITE(6,800)SHPK(K),SHMN(K),PSET(K),FSET(K),SHFORST(K),
     .          AFCP(K)
 999  CONTINUE
      ENDIF

      RETURN
 800  FORMAT(5E12.5)
 776  FORMAT(1X,'ELEM. NO.',2X,'PSH',5X,'DS')
 778  FORMAT(3X,I3,1X,E10.4,2X,F6.2)
 501  FORMAT(20A4)
 525  FORMAT(10X,I3,5X,F10.2)
 533  FORMAT(10X,'NODE=',I6)
 544  FORMAT(/,8X,'LDR',5X,'LOAD')
 600  FORMAT(' PROMPT.....TITLE')
 601  FORMAT(1H1,//1H ,20A4,//)
 602  FORMAT(' PROMPT.....NELEMZ...NODEZ')
 603  FORMAT(' NO. OF ELEMENTS ',I5,' NO. OF NODES',I5)
 604  FORMAT(' ORDER OF GAUSS INTEGRATION RULE = ',I4)
 605  FORMAT(' NUMBER OF VARIABLES (D.O.F.) =',I5)
 606  FORMAT(' PROMPT...ELEMENT NO...TOPOLOGY LIST',/,
     1      '  ELEMENTS IN ASCENDING ORDER .........')
 607  FORMAT(9I4)
 608  FORMAT(' ERROR****ELEMENTS NOT IN ASCENDING ORDER*****')
 609  FORMAT(' ERROR***** ',I5,' EXCEEDS NODEZ')
 610  FORMAT(' PROMPT.... N X Y .. TERNINATE WITH NEG. N ')
 611  FORMAT(' ERROR***** ',I6,' IS GREATER THAN NODEZ ....TRY AGAIN')
 612  FORMAT(I5,2F10.2)
 613  FORMAT(' PROMPT .... NFIXZ')
 614  FORMAT(' NUMBER OF FIXED BOUNDARY NODES',I4)
 615  FORMAT('  NODE   FIXITY CODE')
 616  FORMAT(I5,4X,I4)
 617  FORMAT(/'PRESSURE DATA ..'/
     . '   PRESSURE     .... APPLIED AT NODES .... ')
 618  FORMAT(1H F12.5,4X,8I4)
 620  FORMAT(' NUMBER OF MATERIALS',I4)
 621  FORMAT(' MATERIAL NO.     MATERIAL  PROPERTIES     ')
 622  FORMAT(I10,5X,E11.3,F10.3)
 623  FORMAT(' ELEMENT MATERIAL NUMBERS ....DATA IN PAIRS ',/,
     1   ' IN THE FORM  (ELEMENT,MATERIAL NO.)  ')
 624  FORMAT(I6,I3,I6,I3,I6,I3,I6,I3,I6,I3)
 625  FORMAT(' THIS VALUE IS INADMISSIBLE !! '/ 
     .       ' JOB ABORTED +++++++++',I6,I6,////)
 626  FORMAT(//' ANALYSIS CLASS ... PLANE STRESS'//)
 627  FORMAT(//' ANALYSIS CLASS ... PLANE STRAIN'//)
 628  FORMAT(//' ANALYSIS CLASS ... AXISYMMETRIC'//)
 633  FORMAT(1X,'ELEMENT NUMBERS.......ELEMENT TYPE NUMBERS')
 644  FORMAT(I6,I3,I6,I3,I6,I3,I6,I3,I6,I3)
 648  FORMAT(10X,'POINT LOAD DATA')
 649  FORMAT(10X,'NODE',5X,'DIR. OF LOAD')
 650  FORMAT(10X,I5,5X,I3)
 651  FORMAT(' *** DATA ERROR .. MXEL AND NELEMZ ..',2I5)
 652  FORMAT(' *** DATA ERROR .. MXNOD AND NODEZ ..',2I5)
 653  FORMAT(' *** DATA ERROR .. MXAI AND NVABZ ..',2I5)
 654  FORMAT(' *** DATA ERROR .. MXMAT AND NMAT ..',2I5)
 655  FORMAT(' *** DATA ERROR .. MXFIX AND NFIXZ ..',2I5)
 665  FORMAT(1X,'LINK ELEMENT ANGLE')
 666  FORMAT(F10.2)
 677  FORMAT(1X,'RKX...',15X,'RKY...')
 688  FORMAT(1X,F13.2,10X,F13.2)
 690  FORMAT(1X,I5,5X,I3,5X,E13.4)
      END

$ 