      SUBROUTINE LOAD_FAC(LOAD_FAC1,I_STORE1)
C                                         ANTHONY CARROLL FEB. 1986
C----------------------------------------------------------------------
C   THIS ROUTINE CALCULATES THE MINIMUM LOAD FACTOR FOR THE NEXT STUD
C   TO LOAD UP.____AT PRESENT ONLY FOR INITIAL-STATIC-CYCLIC        "BI"
C              ----         ULTIMATELY INITIAL-STATIC-CYCLIC-STATIC "TRI"
C----------------------------------------------------------------------

      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'STRESS2D.CCM'
      REAL*8 LOAD_FAC1,LF1(MAXSTUDS)
      
      LOAD_FAC1=1.0    !IF NO STUD LOADS FULL REMAINING LOAD IS APPLIED
                       !AND INCREMENTAL PROCEDURE STOPS
      I_STORE1=0       !SAME IDEA AS ABOVE

      DO 10 I=1,NSG
         LF1(I)=2.0   !INITIALLY LF1 MUST BE .GT. LOAD_FAC1

C LOAD FACTORS ARE ONLY CALCULATED AT THOSE STUDS WITH NON ZERO SLIPS AND
C NON ZERO REMAINING SETS IN THE DIRECTION OF SLIP

      IF((SLIP_INC(I).GT.0.0).AND.(REM_SET_POS(I).GT.0.0)) 
     *                                LF1(I)=REM_SET_POS(I)/SLIP_INC(I)
      IF((SLIP_INC(I).LT.0.0).AND.(REM_SET_NEG(I).LT.0.0)) 
     *                                LF1(I)=REM_SET_NEG(I)/SLIP_INC(I)

      IF(LF1(I).LT.LOAD_FAC1) THEN  !THE MINIMUM LOAD FACTOR 
         LOAD_FAC1=LF1(I)           !BECOMES THE NEW LOAD_FAC1
         I_STORE1=I
      END IF
 
 10   CONTINUE
    
      RETURN
      END

$ 